//	ATtiny2313	1MHzi8MHz8j
//	CRCUIC TA2078PRg[

/*
y|[g蓖āz	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	eqB	eqA		CRCUCtrl-A/B
portB	sw	-	-	-	-	-	A/D	A/D		XCb`AACpA/DRo[^
portD	x	LCD	-	LCD	LCD	LCD	LCD	LCD		LCDڑ

yq[Yrbgz(avrsp.exe -rf)	HoאݒŎgp
Low: 01100100
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1
            +-- SPMEN (SPM 1:, 0:L)

yrhz
AVR Studio	4.14.589
WinAVR-20080610		œKIvV:-Os

yz
2010/04/22	v1.00	Program:     944 bytes (46.1% Full)
					Data:         22 bytes (17.2% Full)
				E
*/


#include	<avr/io.h>
#include	<avr/eeprom.h>
#include	<avr/pgmspace.h>
#include	"lcdlib.h"


//ȈA/DRo[^
uint16_t	acadc();	//AZu֐

//LCDɕ\u[Xg^Cv
const	prog_char	//"12345678"	8܂ŁBŒɍ킹ċ󔒂Ŗ߂B
	STR_LO_BOOST[]	= "Rock   ",
	STR_MID_BOOST[]	= "Pop    ",	//"Vocal  "ł悢Ǝv
	STR_HI_BOOST[]	= "Classic",
	STR_FLAT[]		= "Normal ";
	
static	uint8_t	buf[9] = {0};	//8 + kI[

//VU[^̃}[NitHg 5*8j
const	prog_uint8_t	dots[] =
{
	0b11000,
	0b11100,
	0b11110,
	0b11111,
	0b11111,
	0b11110,
	0b11100,
	0b11000
};

//VU[^
//A/Dϊ̒ldBl̕ϊe[u
static	const	uint8_t	STEP_VU[] =
{
//	A/Dl	   dB	
//	18,		//-20
	52,		//-10
	80,		// -7
	98,		// -5
	124,	// -3
	158,	// -1
	176,	//	0
	194,	//	1
	222//,	//	2
//	250		//	3
};

//VU[^̌
#define	VUM_LEN		sizeof(STEP_VU)

//LCD[U[`iLN^R[hj
#define	LCD_GAIJI_VUMARK	0x01

//LCDł̕\ʒu
#define	lcdSetPosBoostType()	lcdSetPos(0, 0)
#define	lcdSetPosVUMeter()		lcdSetPos(0, 1)

//EEPROM̃u[Xg^CṽAhX
#define	ADRS_BOOSTTYPE	0x00

//|[gݒ
#define	BIT_CTRLA	(1 << PA0)
#define	BIT_CTRLB	(1 << PA1)
#define	BIT_SW		(1 << PB7)

enum	E_BOOSTTYPE
{
	EBT_NORMAL,
	EBT_ROCK,
	EBT_POP,
	EBT_CLASSIC,
	EBT_IDX_END
};


int	main(void)
{
	uint8_t	sw, psw;		//XCb`ǂݎ
	uint8_t	swBT;			//XCb`̏Ԃi[z	0:on	0:off
	uint8_t	loopCnt;		//^C~O҂ȂǂɎgJE^
	uint8_t	boostType;		//u[Xg^Cv
	uint8_t	bits;			//|[go͂̃rbgZpϐ
	int8_t	i;
	uint8_t		adval;		//VU[^
	uint16_t	adret;		//VU[^
	
	psw = sw = 0;
	loopCnt = 0;
	swBT = 1;		//N̓XCb`ꂽƂɂiboostType\邽߁j
	
	//|[gݒ
	DDRA	= BIT_CTRLA | BIT_CTRLB;	//CRCU
	PORTB	= BIT_SW;		//XCb`
	
	//LCD
	lcdInit();
	
	//LCD[U[`o^
	for (i = 0; i < 8; i++)
		buf[i] = pgm_read_byte(&dots[i]);
	lcdDefChar(LCD_GAIJI_VUMARK, buf);
	
	//EEPROMOĨu[Xg^Cvǂݍ
	eeprom_busy_wait();
	boostType = eeprom_read_byte((uint8_t*)ADRS_BOOSTTYPE);
	if (EBT_IDX_END <= boostType)
		boostType = EBT_NORMAL;
	
	while (1)
	{
		//XCb`ꂽꍇ
		if (swBT != 0)
		{
			switch (boostType)
			{
			case EBT_ROCK:
				bits = BIT_CTRLA;
				strcpy_P((char *)buf, STR_LO_BOOST);
				break;
			
			case EBT_POP:
				bits = BIT_CTRLA | BIT_CTRLB;
				strcpy_P((char *)buf, STR_MID_BOOST);
				break;
			
			case EBT_CLASSIC:
				bits = BIT_CTRLB;
				strcpy_P((char *)buf, STR_HI_BOOST);
				break;
			
			default:	//EBT_NORMAL
				bits = 0;
				strcpy_P((char *)buf, STR_FLAT);
				break;
			}
			
			PORTA = bits;
			lcdSetPosBoostType();
			lcdPutStr(buf);
			
			//EEPROMɌ݂̃u[Xg^Cv
			eeprom_busy_wait();
			eeprom_write_byte((uint8_t*)ADRS_BOOSTTYPE, boostType);
		}
		
		//XCb`ǂݎ
		swBT = 0;
		if ((++loopCnt & 0x80) == 0x80)		//`^OłxɃ[vԊu󂯂
		{
			sw = PINB & BIT_SW;
			if (psw != sw)
			{
				swBT = ~sw & BIT_SW;
				psw = sw;
			}
		}
		
		//u[Xg^Cv؂ւXCb`ꂽꍇÃu[Xg^CvɕύX
		if (swBT != 0)
			boostType = (boostType + 1) % EBT_IDX_END;
		
		//VU[^
		adret = acadc();	//̒l0`255ɃXP[OiKɁj
		adval = (uint8_t)(adret / 2);		//\
		for (i = VUM_LEN - 1; 0 <= i; i--)
			if (STEP_VU[i] <= adval) break;
		adval = i + 1;
		for (i = 0; i < adval; i++)
			buf[i] = LCD_GAIJI_VUMARK;
		for (i = adval; i < VUM_LEN; i++)
			buf[i] = ' ';
		lcdSetPosVUMeter();
		lcdPutStr(buf);
		
	}	//while()
	
	return 0;
}
